"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _constants = require("./constants");

const readModel = ({
  promise
}, {
  name,
  projection,
  resolvers,
  adapter
}) => {
  if (promise[_constants.symbol].phase !== _constants.Phases.GIVEN_EVENTS) {
    throw new TypeError();
  }

  promise[_constants.symbol].name = name;
  promise[_constants.symbol].projection = projection != null ? projection : {};
  promise[_constants.symbol].resolvers = resolvers != null ? resolvers : {};
  promise[_constants.symbol].adapter = adapter;

  for (const resolverName of Object.keys(promise[_constants.symbol].resolvers)) {
    promise[resolverName] = resolverArgs => {
      promise[_constants.symbol].resolverArgs = resolverArgs;
      promise[_constants.symbol].resolverName = resolverName;
      promise[_constants.symbol].phase = _constants.Phases.RESOLVER;
      return promise;
    };
  }

  promise[_constants.symbol].phase = _constants.Phases.READ_MODEL;
  return promise;
};

var _default = readModel;
exports.default = _default;
//# sourceMappingURL=read-model.js.map